package core;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

public class LCSandNWCalculator {

	
	public static String percent(int a, int b){
		float perc = (a*100)/b;	
		return (perc + " %");
	}
	
	public static void calculate(String stubAdress, SequenceGenerator sg, SequenceEvaluator se) throws IOException{
			    
		for(int g = 0; g<se.definedSequences.length; g++){
	    	String[] sequences = se.definedSequences[g];
	    
	    	String lcsAdress = stubAdress + String.valueOf(g+1) + "_lcs.txt";
	    	System.out.println(lcsAdress);
	    	BufferedWriter lcsWriter = new BufferedWriter(new FileWriter(lcsAdress));
	    	String homologyAdress = stubAdress + String.valueOf(g+1) + "_hom.txt";
	    	BufferedWriter homologyWriter = new BufferedWriter(new FileWriter(homologyAdress));
	    
	    	lcsWriter.write('\t');
	    	homologyWriter.write('\t');
	    	for(int i = 0; i<se.definedSequences[g].length; i++){
	    		lcsWriter.write(String.valueOf(i+1));
	    		lcsWriter.write('\t');
	    		homologyWriter.write(String.valueOf(i+1));
	    		homologyWriter.write('\t');
	    	}
	    
	    	lcsWriter.newLine();
	    	homologyWriter.newLine();
    	
	    	for(int i = 0; i<se.definedSequences[g].length; i++){
	    		lcsWriter.write(String.valueOf(i+1));
	    		homologyWriter.write(String.valueOf(i));
	    		lcsWriter.write('\t');
	    		homologyWriter.write('\t');
	    		for(int j = 0; j<se.definedSequences[g].length; j++){
	    			String sequence1 = sequences[i].substring(sg.prefix.length(), sequences[i].length()-sg.suffix.length());
	    			String sequence2 = sequences[j].substring(sg.prefix.length(), sequences[j].length()-sg.suffix.length());
	    			lcsWriter.write(String.valueOf(longestCommonSubstring.longestSubstring(sequence1, sequence2).length()));
	    			lcsWriter.write('\t');
	    			NeedlemanWunsch NW = new NeedlemanWunsch(sequence1, sequence2);
	    			String percentNW = percent(NW.compare(), sequence1.length());
	    			homologyWriter.write(percentNW);
	    			homologyWriter.write('\t');
	    		}
	    		lcsWriter.newLine();
	    		homologyWriter.newLine();
	    	}
	    
	    	lcsWriter.close();
	    	homologyWriter.close();
	    
	    	System.out.println("LCS + NW " + percent(g, se.definedSequences.length) + " done.");
	    }	
		
	}
}
