package core;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

public class MARSeG {

	public static String reverse(String input)
	  {
	    String output = "";
	    output = new StringBuilder(input).reverse().toString();
	    return output;
	  }
	  
	public static String complement(String input)
	  {
	    String output = "";
	    for (int i = 0; i < input.length(); i++) {
	      if (input.charAt(i) == 'A') {
	        output = output.concat("T");
	      } else if (input.charAt(i) == 'C') {
	        output = output.concat("G");
	      } else if (input.charAt(i) == 'G') {
	        output = output.concat("C");
	      } else if (input.charAt(i) == 'T') {
	        output = output.concat("A");
	      } else if (input.charAt(i) == 'N') {
	        output = output.concat("N");
	      } else if (input.charAt(i) == 'D') {
	        output = output.concat("H");
	      } else if (input.charAt(i) == 'V') {
	        output = output.concat("B");
	      } else if (input.charAt(i) == 'B') {
	        output = output.concat("V");
	      } else if (input.charAt(i) == 'H') {
	        output = output.concat("D");
	      } else if (input.charAt(i) == 'W') {
	        output = output.concat("W");
	      } else if (input.charAt(i) == 'S') {
	        output = output.concat("S");
	      } else if (input.charAt(i) == 'K') {
	        output = output.concat("M");
	      } else if (input.charAt(i) == 'M') {
	        output = output.concat("K");
	      } else if (input.charAt(i) == 'Y') {
	        output = output.concat("R");
	      } else if (input.charAt(i) == 'R') {
	        output = output.concat("Y");
	      } else {
	        System.out.println("Problems in complementation");
	      }
	    }
	    return output;
	  }
	  
	public static String[] createAllMotifs(String motifFileAdress) throws IOException{
		
		BufferedReader inputFile = new BufferedReader(new FileReader(motifFileAdress));
	  	String line = inputFile.readLine();
	  	String[] motif = line.split(" ");
	  	String[] allMotifs = new String[motif.length * 2];
		for (int i = 0; i < motif.length; i++)
	    {
	      allMotifs[i] = motif[i];
	      allMotifs[(motif.length + i)] = reverse(complement(motif[i]));
	    } 
		inputFile.close();
		
		return allMotifs;
	}

	public static void cleanUp(String targetLocation){
		File folder = new File(targetLocation);
		File[] listOfFiles = folder.listFiles();
		
		    for (int i = 0; i < listOfFiles.length; i++) {
		      if (listOfFiles[i].isFile()) {
		        System.out.println("File " + listOfFiles[i].getName());
		        if (listOfFiles[i].getName().contains("out_") && listOfFiles[i].getName().contains("_hom.txt")){
		        	listOfFiles[i].delete();
		        }else if (listOfFiles[i].getName().contains("out_") && listOfFiles[i].getName().contains("_lcs.txt")){
		        	listOfFiles[i].delete();
		        }
		      }
		    }
	}
	
	public static String getPathOfJar(){
		File f = new File(System.getProperty("java.class.path"));
		File dir = f.getAbsoluteFile().getParentFile();
		String path = dir.toString();
		return path;
	}
	
	public static void main(String[] args) throws IOException {
		
		Scanner scan = new Scanner(System.in);
	    System.out.println("Location of motif list: ");
	    String motifAdress = scan.nextLine();
			
	    String targetAdress = "";
	    System.out.println("Where to save to? (folder)");
	    targetAdress = scan.nextLine();
	    boolean isUnix = targetAdress.contains("/");
	    if(isUnix){
	    	targetAdress = targetAdress + "/";
	    }else{
	    	targetAdress = targetAdress + "\\";
	    }
		
	    System.out.println("Pattern for main sequence: ");
	    String mainSequence = scan.nextLine().toUpperCase();
	    
	    System.out.println("Prefix sequence: ");
	    String prefix = scan.nextLine();
	    
	    System.out.println("Suffix sequence: ");
	    String suffix = scan.nextLine();
	    
	    System.out.println("Number of sequences to generate: ");
	    int numberOfDegeneratedSequences = Integer.parseInt(scan.nextLine());
	    
		int numberOfDefinitiveSequences = 100;
		
		System.out.println("Location of Rscript.exe: ");
	    String locationR = scan.nextLine();
		
	    String locationRProgram = getPathOfJar().concat("\\eval.R");
	    System.out.println(locationRProgram);
	    scan.close();
		
		String[] allMotifs = createAllMotifs(motifAdress);
		
		String tmp_path_in = "";
		String tmp_path_out = "";
		if(isUnix){
			tmp_path_in = targetAdress+"out.txt";
			tmp_path_out = targetAdress+"out_";
		}else{
			tmp_path_in = targetAdress+"out.txt";
			tmp_path_out = targetAdress+"out_";
		}
		SequenceGenerator sg = new SequenceGenerator(mainSequence, prefix, suffix, numberOfDegeneratedSequences, allMotifs);
		
		System.out.println("Generated randomized sequences.");
		
		SequenceEvaluator se = new SequenceEvaluator(tmp_path_in, numberOfDefinitiveSequences, tmp_path_out, sg);
		
		System.out.println("Created temporary sequences");
		
		LCSandNWCalculator.calculate(tmp_path_out, sg, se);
		
		System.out.println("Calculated LCS and NW");
		
		if("Linux".equals(System.getProperty("os.name"))){
			System.out.println("Skipped evalution using R.");
		}else{
			String argument = tmp_path_out + " " + String.valueOf(numberOfDegeneratedSequences) + " " + 
				String.valueOf(numberOfDefinitiveSequences); 
			RReader.readRScript(locationR, locationRProgram, argument);
			cleanUp(targetAdress);
		}

		
		System.out.println("Done!");
		
	}

}
