package core;


import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Random;


public class SequenceEvaluator {
	
	String[][] definedSequences;
	
	public SequenceEvaluator(String inputAdress, int numberOfDefinitiveSequences, String outputAdress, SequenceGenerator sg) throws IOException{
		
		evaluate(inputAdress, numberOfDefinitiveSequences, outputAdress, sg);
		
	}
	
	public static String reverse(String input)
	  {
	    String output = "";
	    output = new StringBuilder(input).reverse().toString();
	    return output;
	  }
	  
	  public static String complement(String input)
	  {
	    String output = "";
	    for (int i = 0; i < input.length(); i++) {
	      if (input.charAt(i) == 'A') {
	        output = output.concat("T");
	      } else if (input.charAt(i) == 'C') {
	        output = output.concat("G");
	      } else if (input.charAt(i) == 'G') {
	        output = output.concat("C");
	      } else if (input.charAt(i) == 'T') {
	        output = output.concat("A");
	      } else if (input.charAt(i) == 'N') {
	        output = output.concat("N");
	      } else if (input.charAt(i) == 'D') {
	        output = output.concat("H");
	      } else if (input.charAt(i) == 'V') {
	        output = output.concat("B");
	      } else if (input.charAt(i) == 'B') {
	        output = output.concat("V");
	      } else if (input.charAt(i) == 'H') {
	        output = output.concat("D");
	      } else if (input.charAt(i) == 'W') {
	        output = output.concat("W");
	      } else if (input.charAt(i) == 'S') {
	        output = output.concat("S");
	      } else if (input.charAt(i) == 'K') {
	        output = output.concat("M");
	      } else if (input.charAt(i) == 'M') {
	        output = output.concat("K");
	      } else if (input.charAt(i) == 'Y') {
	        output = output.concat("R");
	      } else if (input.charAt(i) == 'R') {
	        output = output.concat("Y");
	      } else {
	        System.out.println("Problems in complementation");
	      }
	    }
	    return output;
	  }
	  
	  public static String getDefinitiveSequence(String draft, Map<Character, String> table)
	  {
		  //Creates a definitive, random sequence from a degenerate sequence
	    Random randGen = new Random();
	    char[] output = new char[draft.length()];
	    String tempString = "";
	    for (int i = 0; i < draft.length(); i++)
	    {
	      tempString = (String)table.get(Character.valueOf(draft.charAt(i)));
	      output[i] = tempString.charAt(randGen.nextInt(tempString.length()));
	    }
	    return new String(output);
	  }
	  
	  public static double getPercent(int input, int number)
	  {
	    double output = input*100;
	    output = Math.round(output)/ (double) number;
	    return output;
	  }

	  public static double gcContentMultiple(String[] input)
	  {
	    double GC = 0.0D;
	    int length = 0;
	    for (int j = 0; j < input.length; j++) {
	      for (int i = 0; i < input[j].length(); i++)
	      {
	        if (input[j].charAt(i) == 'G') {
	          GC += 1.0D;
	        } else if (input[j].charAt(i) == 'C') {
	          GC += 1.0D;
	        }
	        length++;
	      }
	    }
	    GC = GC / length * 100.0D;
	    GC = Math.round(GC * 100.0D);
	    return GC / 100.0D;
	  }
	  
	  public static List<String> contains(String sequence, String motif)
	  {
	    Map<Character, Integer> charToInt = new HashMap<Character, Integer>();
	    charToInt.put(Character.valueOf('A'), Integer.valueOf(8));
	    charToInt.put(Character.valueOf('C'), Integer.valueOf(4));
	    charToInt.put(Character.valueOf('G'), Integer.valueOf(2));
	    charToInt.put(Character.valueOf('T'), Integer.valueOf(1));
	    charToInt.put(Character.valueOf('N'), Integer.valueOf(15));
	    charToInt.put(Character.valueOf('D'), Integer.valueOf(11));
	    charToInt.put(Character.valueOf('V'), Integer.valueOf(14));
	    charToInt.put(Character.valueOf('B'), Integer.valueOf(7));
	    charToInt.put(Character.valueOf('H'), Integer.valueOf(13));
	    charToInt.put(Character.valueOf('W'), Integer.valueOf(9));
	    charToInt.put(Character.valueOf('S'), Integer.valueOf(6));
	    charToInt.put(Character.valueOf('K'), Integer.valueOf(3));
	    charToInt.put(Character.valueOf('M'), Integer.valueOf(12));
	    charToInt.put(Character.valueOf('Y'), Integer.valueOf(5));
	    charToInt.put(Character.valueOf('R'), Integer.valueOf(10));
	    
	    Map<Integer, Character> invMap = new HashMap<Integer, Character>();
	    for (Map.Entry<Character, Integer> entry : charToInt.entrySet())
	    {
	      Character key = (Character)entry.getKey();
	      Integer value = (Integer)entry.getValue();
	      invMap.put(value, key);
	    }
	    
	    String hit = "";
	    List<String> hitList = new LinkedList<String>();
	    
	    int[] intSequence = new int[sequence.length()];
	    int[] intMotif = new int[motif.length()];
	    for (int i = 0; i < sequence.length(); i++) {
	      intSequence[i] = ((Integer)charToInt.get(Character.valueOf(sequence.charAt(i)))).intValue();
	    }
	    for (int i = 0; i < motif.length(); i++) {
	      intMotif[i] = ((Integer)charToInt.get(Character.valueOf(motif.charAt(i)))).intValue();
	    }
	    int temp = 0;
	    for (int i = 0; i < sequence.length() - motif.length() + 1; i++)
	    {
	      for (int l = 0; l < motif.length(); l++)
	      {
	        if ((intSequence[(i + l)] & intMotif[l]) != 0) {
	          temp++;
	        }
	        if (temp == motif.length())
	        {
	          hit = " ";
	          for (int k = 0; k < motif.length(); k++) {
	            hit = hit.concat(String.valueOf(invMap.get(Integer.valueOf(intSequence[(i + k)]))));
	          }
	          hitList.add(hit);
	        }
	      }
	      temp = 0;
	    }
	    return hitList;
	  }
	 
	  public void evaluate(String inputAdress,int numberOfDefinitiveSequences,
			  String outputAdress, SequenceGenerator sg) throws IOException{
		  		    			  			    		
		    //Creates one file for each input sequence, where numberOfDefinitiveSequences are generated into
		    //String outAdress = outputAdress + 1 + ".txt";
		    double[] gc = new double[sg.degeneratedSequences.length];
		    
		    int[] amountOfSubfilesWithMotifs = new int[sg.degeneratedSequences.length];
		    int[] occurrencesOfMotifs = new int[sg.allMotifs.length];
			for (int i = 0; i < sg.allMotifs.length; i++)
		    {
		      occurrencesOfMotifs[i] = 0;
		    } 
		    
		    definedSequences = new String[sg.degeneratedSequences.length][numberOfDefinitiveSequences];
		    for (int p = 0; p < sg.degeneratedSequences.length; p++)
		    {	
		    	amountOfSubfilesWithMotifs[p] = 0;
		      
		    	for (int k = 0; k < numberOfDefinitiveSequences; k++)
		    	{  
		    	  definedSequences[p][k] = getDefinitiveSequence(sg.degeneratedSequences[p], sg.translator);
		    	  String tempDNA = definedSequences[p][k].substring(sg.prefix.length(), definedSequences[p][k].length()-sg.suffix.length());
		    	  
		    	  boolean sequenceContainsMotifs = false;
		    	  for(int j = 0; j<sg.allMotifs.length; j++){
		    		  List<String> ListOfMotifsInSequence = contains(tempDNA,sg.allMotifs[j]);
		    		  if(!ListOfMotifsInSequence.isEmpty()){
		    			  sequenceContainsMotifs = true;
		    		  }
		    		  occurrencesOfMotifs[j] = occurrencesOfMotifs[j]+ListOfMotifsInSequence.size();
		    	  }
		    	  if(sequenceContainsMotifs){
		    		  amountOfSubfilesWithMotifs[p]++;
		    	  }
		    	}
		    	 
		      System.out.println("Done computing single sequence file for randomized sequence " + p);
		    
		      gc[p] = gcContentMultiple(definedSequences[p]);
		    }
		    
		    System.out.println("Done with gc-content.");
		    String lastAdress = inputAdress;
		    
		    BufferedWriter bw = new BufferedWriter(new FileWriter(lastAdress));
		    int overPointer = 0;
		    for (int i = 0; i < sg.degeneratedSequences.length; i++) {
		    	bw.write(sg.informationOfDegenSequences[i]);
		        bw.write(" GC content: " + gc[overPointer] + "%");
		        bw.write(" Fraction of sequences with motifs: " + 
		        		getPercent(amountOfSubfilesWithMotifs[overPointer], numberOfDefinitiveSequences) + "%");
		        overPointer++;
		        bw.newLine();
		        bw.write(sg.degeneratedSequences[i]);
		        bw.newLine();
		      }
		    bw.close();
	  }
}
